;+
;
; @file_comments
; gives fictype ('DA' 'MO' 'AN' 'SE' 'EX') corresponding
; to the given date in vairmer format ( yymmdd )
;
; @param vdate {in}{required}
;
; @param dim
; unused
;
; @uses
; common.pro
;
; @examples
; IDL> fictype = fictype(930124)
;
; @history
; Jerome Vialard  (jv\@lodyc.jussieu.fr)
; 2/7/98
;
; @version
; $Id$
;
;-
function fictype, vdate, dim
;
  compile_opt idl2, strictarrsubs, obsolete
;
@common
;------------------------------------------------------------
;   constitution de l'adresse ou aller chercher le fichier
;--------------------------------------------------------------
; date yymmdd = vdate
   jul = juldate(vdate)
;
   case 1 of
      (year eq 0) and (month eq 0) : return, 'EX'
      (year eq 0) and (month ne 0) and (day eq 0) : return, 'SE'
      (year ne 0) and (month eq 0) : return, 'AN'
      (year ne 0) and (day eq 0)   : return, 'MO'
      else                         : return, 'DA'
   endcase
;
;------------------------------------------------------------
   fini:
;
   return, -1
end
;------------------------------------------------------------
