;+
;
; @file_comments
;
; @categories
;
; @keyword IMAGE
;
; @history
; Sebastien Masson
;
; @version
; $Id$
;
;-
PRO tst_plt_old, IMAGE = image
;
  compile_opt idl2, strictarrsubs
;
@common
;
; figure 2: regular grid
;
  CASE jpi*key_stride[0]+jpj*key_stride[1] OF
    180+148:file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA2.nc'
    360+180:file = 'Levitus98_1m_01_12_Temperature_Pot_1x1.nc'
    720+510:file = 'Levitus98_1m_01_12_Temperature_Pot_ORCA05.nc'
  ENDCASE
  file = isafile(file, title = 'Where is '+file+' ?', /lookalldir)
  IF size(file, /type) NE 7 THEN return
;
  dummy = ''
  cnt = 1
;
  domdef
  domdef, gdept[0], gdept[0], grille = 'T'
  temp = read_ncdf('votemper', 00101, 00131, file = file)
;
  plt, temp, /landscape
  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
  ELSE read, dummy,  prompt = 'press return for the next plot'
  cnt = cnt + 1
;
  plt, temp, -2, 31, int = .5, /nocontour, format = '(i3)'
  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
  ELSE read, dummy,  prompt = 'press return for the next plot'
  cnt = cnt + 1
;
  plt, temp, -2, 31, int = 1, /color_c
  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
  ELSE read, dummy,  prompt = 'press return for the next plot'
  cnt = cnt + 1
;
  plt, temp, -2, 31, int = 1, /nocouleur, c_thick = 1, cont_thick = 2
  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
  ELSE read, dummy,  prompt = 'press return for the next plot'
  cnt = cnt + 1
;
  plt, temp, cell_fill = 1 + (jpi EQ 180) ; we must use cell_fill = 2 for ORCA2
  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
  ELSE read, dummy,  prompt = 'press return for the next plot'
  cnt = cnt + 1
; zoom
  IF key_onearth THEN box = [40, 375, -20, 20] $
  ELSE box = [jpi/4, 3*jpi/4, jpj/4, 3*jpj/4]
  plt, temp, boite = box, /landscape
  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
  ELSE read, dummy,  prompt = 'press return for the next plot'
  cnt = cnt + 1

; projections
  IF key_onearth THEN BEGIN
;
    plt, temp, boite = [20, 380, 60, 90], /stereo, map = [90, 0, 0], /portrait
    if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
    ELSE read, dummy,  prompt = 'press return for the next plot'
    cnt = cnt + 1
;
    plt, temp, boite = [20, 380, -90, 50], /ortho, map = [-90, 180, 0], /portrait
    if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
    ELSE read, dummy,  prompt = 'press return for the next plot'
    cnt = cnt + 1
;
    plt, temp, /ortho, map = [0, 0, 21], /portrait, /carte
    if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png $
    ELSE read, dummy,  prompt = 'press return for the next plot'
    cnt = cnt + 1
;
  ENDIF

; deep plot
; domdef, 150, 150 ; => warning message
  domdef, gdept[jpk/2], gdept[jpk/2], grille = 'T'
  temp = read_ncdf('votemper', 00101, 00131, file = file)
  plt, temp, carte = 2*(key_onearth), /land
  if keyword_set(image) then saveimage, 'tst_plt_'+image+'_'+string(cnt, format='(i2.2)')+'.png', /png
  cnt = cnt + 1


  return
end
